Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class Atomizer

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.Atomizer

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, org.xml.sax.Locator

    public final class Atomizer

extends UnaryExpression

An Atomizer is an expression corresponding essentially to the fn:data() function: it maps a sequence by replacing nodes with their typed values

See Also:
  Serialized Form

Nested Class Summary
`static class` | `Atomizer.AtomizingFunction` Implement the mapping function.

Field Summary

Fields inherited from class net.sf.saxon.expr.UnaryExpression
`operand`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`Atomizer(Expression sequence, Configuration config)` Constructor

Method Summary
`PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
`int` | `computeCardinality()` Determine the static cardinality of the expression
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`Expression` | `copy()` Copy an expression.
`java.lang.String` | `displayExpressionName()` Diagnostic print of expression structure.
`Item` | `evaluateItem(XPathContext context)` Evaluate as an Item.
`static ItemType` | `getAtomizedItemType(Expression operand, boolean alwaysUntyped, TypeHierarchy th)` Compute the type that will result from atomizing the result of a given expression
`static SequenceIterator` | `getAtomizingIterator(SequenceIterator base)` Get an iterator that returns the result of atomizing the sequence delivered by the supplied iterator
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression, if possible
`SequenceIterator` | `iterate(XPathContext context)` Iterate over the sequence of values
`Expression` | `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression
`Expression` | `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`displayOperator, equals, explain, getBaseExpression, hashCode, iterateSubExpressions, promote, replaceSubExpression, toString`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isUpdatingExpression, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Atomizer

    public Atomizer(Expression sequence,
                    Configuration config)

  Constructor

  Parameters:
    `sequence` - the sequence to be atomized
    `config` - the Configuration. Used only for optimization, may be null. Atomization is faster if it is known in advance that all nodes will be untyped.

Method Detail

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `UnaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate as an Item. This should only be called if the Atomizer has cardinality zero-or-one, which will only be the case if the underlying expression has cardinality zero-or-one.

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression, if possible

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER. For this class, the result is always an atomic type, but it might be more specific.

### getAtomizedItemType

    public static ItemType getAtomizedItemType(Expression operand,
                                               boolean alwaysUntyped,
                                               TypeHierarchy th)

  Compute the type that will result from atomizing the result of a given expression

  Parameters:
    `operand` - the given expression
    `alwaysUntyped` - true if it is known that nodes will always be untyped
    `th` - the type hierarchy cache
  Returns:
    the item type of the result of evaluating the operand expression, after atomization

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Overrides:
    `computeCardinality` in class `UnaryExpression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### addToPathMap

    public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                               PathMap.PathMapNodeSet pathMapNodeSet)

  Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

  The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

  Overrides:
    `addToPathMap` in class `Expression`
  Parameters:
    `pathMap` - the PathMap to which the expression should be added
    `pathMapNodeSet` - the PathMapNodeSet to which the paths embodied in this expression should be added
  Returns:
    the pathMapNodeSet representing the points in the source document that are both reachable by this expression, and that represent possible results of this expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

### getAtomizingIterator

    public static SequenceIterator getAtomizingIterator(SequenceIterator base)

  Get an iterator that returns the result of atomizing the sequence delivered by the supplied iterator

  Parameters:
    `base` - the supplied iterator, the input to atomization
  Returns:
    an iterator that returns atomic values, the result of the atomization

### displayExpressionName

    public java.lang.String displayExpressionName()

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Overrides:
    `displayExpressionName` in class `UnaryExpression`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) Saxonica Limited. All rights reserved.